import { EventEmitter, ComponentInterface } from '../../stencil-public-runtime';
export declare class Button implements ComponentInterface {
    private inheritAttributes;
    el: HTMLElement;
    color: BalProps.BalButtonColor;
    elementType: BalProps.BalButtonElementType;
    disabled: boolean;
    size: BalProps.BalButtonSize;
    href?: string;
    target: BalProps.BalButtonTarget;
    rel?: string;
    download?: string;
    shadow: boolean;
    square: boolean;
    isActive: boolean;
    expanded: boolean;
    flat: boolean;
    outlined: boolean;
    inverted: boolean;
    loading: boolean;
    rounded: boolean;
    topRounded: undefined | boolean;
    bottomRounded: undefined | boolean;
    icon: string;
    iconTurn: boolean;
    iconRight: string;
    noWrap: boolean;
    name?: string;
    value?: string | number;
    aria?: BalProps.BalButtonAria;
    balNavigate: EventEmitter<BalEvents.BalButtonNavigateDetail>;
    balFocus: EventEmitter<BalEvents.BalButtonFocusDetail>;
    balBlur: EventEmitter<BalEvents.BalButtonBlurDetail>;
    balDidRender: EventEmitter<BalEvents.BalButtonDidRenderDetail>;
    listenOnClick(ev: UIEvent): void;
    componentWillLoad(): void;
    componentDidRender(): void;
    private get isIconInverted();
    private get buttonCssClass();
    private get leftIconAttrs();
    private get leftRightAttrs();
    private get loadingAttrs();
    private handleClick;
    private onFocus;
    private onBlur;
    private onClick;
    render(): any;
}
