import { EventEmitter } from '../../stencil-public-runtime';
import { BalAriaForm, BalAriaFormLinking } from '../../utils/form';
export declare class InputSlider implements BalAriaFormLinking {
    el: HTMLElement;
    private inputId;
    private nativeInput?;
    private didInit;
    private hasFocus;
    private initialValue?;
    ariaForm: BalAriaForm;
    name: string;
    step: number;
    min: number;
    max: number;
    invalid: boolean;
    balTabindex: number;
    disabled: boolean;
    readonly: boolean;
    required: boolean;
    hasTicks: boolean;
    debounce: number;
    protected debounceChanged(): void;
    value?: string | number;
    autoInvalidOff: boolean;
    balInput: EventEmitter<BalEvents.BalInputSliderInputDetail>;
    balBlur: EventEmitter<BalEvents.BalInputSliderBlurDetail>;
    balKeyPress: EventEmitter<BalEvents.BalInputSliderKeyPressDetail>;
    balFocus: EventEmitter<BalEvents.BalInputSliderFocusDetail>;
    balChange: EventEmitter<BalEvents.BalInputSliderChangeDetail>;
    listenOnClick(ev: UIEvent): void;
    private resetHandlerTimer?;
    resetHandler(ev: UIEvent): void;
    protected valueChanged(newValue: string | number | undefined, oldValue: string | number | undefined): void;
    connectedCallback(): void;
    componentDidLoad(): void;
    private setFocusTimer?;
    setFocus(): Promise<void>;
    getInputElement(): Promise<HTMLInputElement | undefined>;
    setAriaForm(ariaForm: BalAriaForm): Promise<void>;
    get numberOfSteps(): number;
    private cssWidth;
    private onInput;
    private handleClick;
    private onFocus;
    private onBlur;
    private getNumberOfSteps;
    render(): any;
}
