import { ComponentInterface } from '../../stencil-public-runtime';
import { LevelInfo } from './utils/level.utils';
import { BalBreakpointObserver, BalBreakpoints } from '../../utils/breakpoints';
export declare class Navigation implements ComponentInterface, BalBreakpointObserver {
    el: HTMLElement;
    private mutationO?;
    private mainNavElement?;
    private mainNavTabsEl?;
    private previousY;
    private bodyScrollBlocker;
    mainMobileHeight: string;
    isMetaHidden: boolean;
    levels: LevelInfo[];
    selectedMetaIndex: number;
    selectedMainIndex: number;
    isMainBodyOpen: boolean;
    selectedMetaValue?: string | undefined;
    selectedMainValue?: string | undefined;
    isTouch: boolean;
    isDesktop: boolean;
    logoAnimated: boolean;
    logoPath: string;
    ariaLabelMeta: string;
    ariaLabelMain: string;
    metaValue?: string;
    clickOnOutside(ev: UIEvent): Promise<void>;
    private get metaMobileActionsElement();
    private get metaDesktopEndElement();
    breakpointListener(breakpoints: BalBreakpoints): void;
    orientationHandler(): Promise<void>;
    handleScroll(_event: Event): void;
    connectedCallback(): Promise<void>;
    disconnectedCallback(): void;
    componentDidLoad(): void;
    componentDidUpdate(): void;
    bodyOffset: number;
    private listenToPopoverChangeEvent;
    private updateIndexes;
    private readSubLevels;
    private getMaxHeight;
    private dismissPopover;
    private onBurgerButtonClick;
    onMainTabChange: (ev: BalEvents.BalTabsChange) => Promise<void>;
    render(): any;
}
