import { ComponentInterface, EventEmitter } from '../../stencil-public-runtime';
import { BalConfigObserver, BalConfigState, BalLanguage, BalRegion } from '../../utils/config';
import { FormInput } from '../../utils/form-input';
import { BalAriaForm, BalAriaFormLinking } from '../../utils/form';
import { LogInstance, Loggable } from '../../utils/log';
export declare class TimeInput implements ComponentInterface, BalConfigObserver, FormInput<string | undefined>, BalAriaFormLinking, Loggable {
    private inputId;
    private inheritedAttributes;
    nativeInput?: HTMLInputElement;
    inputValue: string | undefined;
    initialValue: string;
    el: HTMLElement;
    log: LogInstance;
    createLogger(log: LogInstance): void;
    focused: boolean;
    language: BalLanguage;
    region: BalRegion;
    ariaForm: BalAriaForm;
    name: string;
    invalid: boolean;
    required: boolean;
    disabled: boolean;
    readonly: boolean;
    debounce: number;
    protected debounceChanged(): void;
    value?: string;
    autoInvalidOff: boolean;
    balInput: EventEmitter<BalEvents.BalTimeInputInputDetail>;
    balChange: EventEmitter<BalEvents.BalTimeInputChangeDetail>;
    balBlur: EventEmitter<BalEvents.BalTimeInputBlurDetail>;
    balFocus: EventEmitter<BalEvents.BalTimeInputFocusDetail>;
    balKeyPress: EventEmitter<BalEvents.BalTimeInputKeyPressDetail>;
    balClick: EventEmitter<BalEvents.BalTimeInputClickDetail>;
    listenOnClick(ev: UIEvent): void;
    private resetHandlerTimer?;
    resetHandler(ev: UIEvent): void;
    connectedCallback(): void;
    componentDidLoad(): void;
    componentWillLoad(): void;
    configChanged(state: BalConfigState): Promise<void>;
    setFocus(): Promise<void>;
    setBlur(): Promise<void>;
    getInputElement(): Promise<HTMLInputElement>;
    setAriaForm(ariaForm: BalAriaForm): Promise<void>;
    private getAllowedKeys;
    private getRawValue;
    private getFormattedValue;
    private onInput;
    private onFocus;
    private onBlur;
    private onKeydown;
    render(): any;
}
