import { DateTime } from 'luxon';
export interface BalDateInfoOptions {
    format?: 'narrow' | 'short' | 'long';
    locale?: string;
}
export declare class BalDate {
    private dt;
    static fromAnyFormat(value: string): BalDate;
    static fromISO(value: string | undefined): BalDate;
    static infoMonths({ format, locale }?: BalDateInfoOptions): string[];
    static infoWeekdays({ format, locale }?: BalDateInfoOptions): string[];
    constructor(dt: DateTime);
    get isValid(): boolean;
    toISO(): string | null;
    toISODate(): string;
    toFormat(): string;
    isBefore(isoDate: string): boolean;
    isBeforeOrEqual(isoDate: string): boolean;
    isAfter(isoDate: string): boolean;
    isAfterOrEqual(isoDate: string): boolean;
    get month(): number | undefined;
    get year(): number | undefined;
}
