import { MaskContextEvent, MaskContextOptions } from './mask-context-interfaces';
import { MaskPosition } from './mask-position';
export declare abstract class MaskContext<T = MaskContextEvent> {
    protected _options: MaskContextOptions<T>;
    private _value;
    position: MaskPosition;
    constructor(_options: MaskContextOptions<T>);
    get target(): HTMLInputElement | undefined;
    get value(): string;
    set value(newValue: string);
    get focused(): boolean;
    isValueEmpty(): boolean;
    preventDefault(): void;
    stopPropagation(): void;
    submit(eventType?: 'input' | 'change' | 'blur' | 'tab', parsedValue?: string): Promise<void>;
}
