import { MaskContext } from './mask-context';
import { MaskContextEvent } from './mask-context-interfaces';
export interface MaskKeyboardContextEvent extends MaskContextEvent {
    key: string;
    metaKey?: boolean;
    ctrlKey?: boolean;
}
export declare class MaskKeyboardContext extends MaskContext<MaskKeyboardContextEvent> {
    private static NUMBER_KEYS;
    private static NAVIGATION_KEYS;
    get key(): string;
    get isCtrlOrCommandKey(): boolean | undefined;
    get isBackspaceKey(): boolean;
    get isTabKey(): boolean;
    get isWhiteSpaceKey(): boolean;
    get isDeleteKey(): boolean;
    get isNumberKey(): boolean;
    get isNavigationKey(): boolean;
    get isSelectAllCommand(): boolean | undefined;
    get isCopyCommand(): boolean | undefined;
    get isPasteCommand(): boolean | undefined;
    getCharAt(position?: number): string;
    getCharAtBackspacePosition(): string;
    setChar(char?: string, position?: number): void;
}
