import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { B as BEM } from './bem.js';

const balListCss = ":root{--bal-list-item-radius:var(--bal-radius-normal);--bal-list-item-subtile-color:var(--bal-color-text-primary);--bal-list-item-background-hover:var(--bal-color-light-blue-5);--bal-list-item-background-active:var(--bal-color-primary-6);--bal-list-item-on-dark-color:var(--bal-color-text-white);--bal-list-item-on-dark-background-hover:var(--bal-color-light-blue-2);--bal-list-item-on-dark-background-active:var(--bal-color-light-blue-4);--bal-list-item-disabled-color:var(--bal-color-text-grey);--bal-list-item-disabled-fill:var(--bal-color-grey-5);--bal-list-item-disabled-background:var(--bal-color-grey-2);--bal-list-item-disabled-on-dark-background:var(--bal-color-primary-4);--bal-list-item-disabled-on-dark-color:var(--bal-color-text-grey);--bal-list-item-disabled-on-dark-fill:var(--bal-color-grey-5);--bal-list-item-disabled-on-color-background:var(--bal-color-primary-4);--bal-list-item-disabled-on-color-color:var(--bal-color-primary-4);--bal-list-item-disabled-on-color-fill:var(--bal-color-primary-4);--bal-list-item-border-background:var(--bal-color-grey-2);--bal-list-item-border-on-color-background:var(--bal-color-primary);--bal-list-item-border-on-dark-background:var(--bal-color-primary-4);--bal-list-accordion-head-color-hover:var(--bal-color-text-light-blue);--bal-list-accordion-head-background-hover:var(--bal-color-light-blue-5);--bal-list-accordion-head-color-active:var(--bal-color-text-primary-dark);--bal-list-accordion-head-background-active:var(--bal-color-primary-6);--bal-list-accordion-body-color:var(--bal-color-text-white);--bal-list-accordion-head-on-dark-color-hover:var(--bal-color-light-blue-2);--bal-list-accordion-head-on-dark-background-hover:var(--bal-color-light-blue-2);--bal-list-accordion-head-on-dark-color-active:var(--bal-color-light-blue-3);--bal-list-accordion-head-on-dark-background-active:var(--bal-color-light-blue-3)}.bal-list,.bal-list__item,.bal-list__item>a,.bal-list__item>button,.bal-list__item>div,.bal-list__item__icon,.bal-list__item__title,.bal-list__item__link,.bal-list__item__subtitle,.bal-list__item__content{position:static;display:-ms-flexbox;display:flex}.bal-list,.bal-list__item__content{-ms-flex-direction:column;flex-direction:column}.bal-list__item__title,.bal-list__item__subtitle{text-align:left}.bal-list,.bal-list__item,.bal-list__item>div,.bal-list__item>a,.bal-list__item>button{width:100%}.bal-list__item,.bal-list__item>a,.bal-list__item>div,.bal-list__item>button{-ms-flex-align:center;align-items:center;-webkit-column-gap:1rem;-moz-column-gap:1rem;column-gap:1rem}.bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body),.bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body)>a,.bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body)>div,.bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body)>button{min-height:3.5rem}.bal-list--size-small .bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body),.bal-list--size-small .bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body)>a,.bal-list--size-small .bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body)>div,.bal-list--size-small .bal-list__item:not(.bal-list__item__accordion-head):not(.bal-list__item__accordion-body)>button{min-height:3rem}.bal-list__item>a,.bal-list__item>div,.bal-list__item>button{padding:.5rem 0;margin:0;outline:none;border-radius:var(--bal-list-item-radius)}.bal-list--size-small .bal-list__item>a,.bal-list--size-small .bal-list__item>div,.bal-list--size-small .bal-list__item>button{padding:2px 0}.bal-list__item{position:relative}.bal-list__item a{text-decoration:none}.bal-list__item button{background:rgba(0,0,0,0);border:none}.bal-list__item__subtitle{color:var(--bal-list-item-subtile-color);font-size:var(--bal-size-small);line-height:var(--bal-line-height-small)}@media screen and (min-width: 769px),print{.bal-list__item__subtitle{font-size:var(--bal-size-tablet-small);line-height:var(--bal-line-height-tablet-small)}}@media screen and (min-width: 1024px){.bal-list__item__subtitle{font-size:var(--bal-size-desktop-small);line-height:var(--bal-line-height-desktop-small)}}.bal-list__item:not(.bal-list__item__accordion-head),.bal-list__item:not(.bal-list__item__accordion-head)>a,.bal-list__item:not(.bal-list__item__accordion-head)>div,.bal-list__item:not(.bal-list__item__accordion-head)>button,.bal-list__item__content{-ms-flex:1;flex:1}.bal-list__item__content{-ms-flex-pack:center;justify-content:center}.bal-list__item__content--start{-ms-flex-pack:start;justify-content:flex-start}.bal-list__item__content--center{-ms-flex-pack:center;justify-content:center}.bal-list__item__content--end{-ms-flex-pack:end;justify-content:flex-end}.bal-list__item__content--space-between{-ms-flex-pack:justify;justify-content:space-between}.bal-list__item__icon{min-width:1.5rem;min-height:3.5rem;-ms-flex-pack:center;justify-content:center;-ms-flex-align:center;align-items:center}.bal-list--size-small .bal-list__item__icon{min-height:calc(3rem - 4px)}.bal-list--size-normal>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-head>.bal-list__item__icon,.bal-list--size-normal>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-head{min-height:3rem}.bal-list--size-small>.bal-list__item:not(.bal-list__item__accordion-body),.bal-list--size-small>.bal-list__item:not(.bal-list__item__accordion-body)>a,.bal-list--size-small>.bal-list__item:not(.bal-list__item__accordion-body)>div,.bal-list--size-small>.bal-list__item:not(.bal-list__item__accordion-body)>button,.bal-list--size-small>.bal-list__item>.bal-list__item__icon{min-height:3rem}.bal-list--size-large>.bal-list__item:not(.bal-list__item__accordion-body),.bal-list--size-large>.bal-list__item:not(.bal-list__item__accordion-body)>a,.bal-list--size-large>.bal-list__item:not(.bal-list__item__accordion-body)>div,.bal-list--size-large>.bal-list__item:not(.bal-list__item__accordion-body)>button,.bal-list--size-large>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-head>.bal-list__item__icon,.bal-list--size-large>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-head,.bal-list--size-large>.bal-list__item>.bal-list__item__icon{min-height:4.5rem}.bal-list--size-large>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-head>.bal-list__item__icon,.bal-list--size-large>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-head{min-height:3.5rem}.bal-list__item--clickable .bal-list__item__accordion-head,.bal-list__item--clickable a:not(.is-link),.bal-list__item--clickable button:not(.button){cursor:pointer;pointer-events:inherit}@media (hover: hover)and (pointer: fine){.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__title .title,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__title .bal-heading__text,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__subtitle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__title .title,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__subtitle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__title .title,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__subtitle{color:var(--bal-list-accordion-head-color-hover) !important}.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg g,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg path,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg circle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg g,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg path,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg circle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg g,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg path,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg circle{fill:var(--bal-list-accordion-head-background-hover) !important}}@media screen and (min-width: 1024px){.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__title .title,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__title .bal-heading__text,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__subtitle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__title .title,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__title .bal-heading__text,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__subtitle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__title .title,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__title .bal-heading__text,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__subtitle{color:var(--bal-list-accordion-head-color-active) !important}}@media screen and (min-width: 1024px){.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg g,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg path,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg circle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg g,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg path,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg circle,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg g,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg path,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg circle{fill:var(--bal-list-accordion-head-background-active) !important}}.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:focus-visible,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):focus-visible,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):focus-visible{-webkit-box-shadow:var(--bal-focus-shadow) !important;box-shadow:var(--bal-focus-shadow) !important}.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable .bal-list__item__accordion-head:focus-visible:after,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable a:not(.is-link):focus-visible:after,.bal-list:not(.is-disabled):not(.bal-list--background-dark) .bal-list__item--clickable button:not(.button):focus-visible:after{content:none !important}.bal-list--background-dark .bal-list__item .bal-list__item__title .title,.bal-list--background-dark .bal-list__item .bal-list__item__title .bal-heading__text,.bal-list--background-dark .bal-list__item .bal-list__item__subtitle{color:var(--bal-list-item-on-dark-color)}.bal-list--background-dark .bal-list__item__icon svg,.bal-list--background-dark .bal-list__item__icon svg g,.bal-list--background-dark .bal-list__item__icon svg path,.bal-list--background-dark .bal-list__item__icon svg circle{fill:var(--bal-list-item-on-dark-color)}@media (hover: hover)and (pointer: fine){.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__subtitle{color:var(--bal-list-accordion-head-on-dark-color-hover) !important}.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):hover .bal-list__item__icon svg circle{fill:var(--bal-list-accordion-head-on-dark-background-hover) !important}}@media screen and (min-width: 1024px){.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__subtitle{color:var(--bal-list-accordion-head-on-dark-color-active) !important}}@media screen and (min-width: 1024px){.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):active .bal-list__item__icon svg circle{fill:var(--bal-list-accordion-head-on-dark-background-active) !important}}.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:focus-visible,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):focus-visible,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):focus-visible{-webkit-box-shadow:var(--bal-focus-shadow-inverted) !important;box-shadow:var(--bal-focus-shadow-inverted) !important}.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable .bal-list__item__accordion-head:focus-visible:after,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable a:not(.is-link):focus-visible:after,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--clickable button:not(.button):focus-visible:after{content:none !important}.bal-list--disabled,.bal-list--disabled .bal-list__item,.bal-list--disabled .bal-list__item a:not(.is-link),.bal-list--disabled .bal-list__item button:not(.button){cursor:default !important;pointer-events:none !important;-webkit-user-select:none !important;-moz-user-select:none !important;-ms-user-select:none !important;user-select:none !important}.bal-list--border:not(.bal-list--nested)>.bal-list__item>div:after,.bal-list--border:not(.bal-list--nested)>.bal-list__item>a.bal-list__item__trigger:not(.is-link):after,.bal-list--border:not(.bal-list--nested)>.bal-list__item>button.bal-list__item__trigger:not(.button):not([type=button]):after,.bal-list--border.bal-list--nested>.bal-list__item:not(:last-child)>div:after,.bal-list--border.bal-list--nested>.bal-list__item:not(:last-child)>a.bal-list__item__trigger:not(.is-link):after,.bal-list--border.bal-list--nested>.bal-list__item:not(:last-child)>button.bal-list__item__trigger:not(.button):not([type=button]):after{content:\"\";height:2px;border-radius:var(--bal-list-item-radius);width:100%;position:absolute;bottom:0;left:0;right:0}.bal-list--border .bal-list__item>div:after,.bal-list--border .bal-list__item a:not(.is-link):after,.bal-list--border .bal-list__item button:not(.button):not([type=button]):after,.bal-list--border .bal-list__item--disabled>div:after,.bal-list--border .bal-list__item--disabled a:not(.is-link):after,.bal-list--border .bal-list__item--disabled button:not(.button):not([type=button]):after{background:var(--bal-list-item-disabled-background)}@media (hover: hover)and (pointer: fine){.bal-list--border .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled)>div:hover:after,.bal-list--border .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) a:not(.is-link):hover:after,.bal-list--border .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) button:not(.button):hover:after{background:var(--bal-list-item-background-hover)}}@media screen and (min-width: 1024px){.bal-list--border .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled)>div:active:after,.bal-list--border .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) a:not(.is-link):active:after,.bal-list--border .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) button:not(.button):active:after{background:var(--bal-list-item-background-active)}}.bal-list--border.bal-list--background-color .bal-list__item>div:after,.bal-list--border.bal-list--background-color .bal-list__item a:not(.is-link):after,.bal-list--border.bal-list--background-color .bal-list__item button:not(.button):after{background:var(--bal-color-primary)}.bal-list--border.bal-list--background-color .bal-list__item--disabled>div:after,.bal-list--border.bal-list--background-color .bal-list__item--disabled a:not(.is-link):after,.bal-list--border.bal-list--background-color .bal-list__item--disabled button:not(.button):after{background:var(--bal-list-item-disabled-on-color-background)}.bal-list--border.bal-list--background-dark .bal-list__item>div:after,.bal-list--border.bal-list--background-dark .bal-list__item a:not(.is-link):after,.bal-list--border.bal-list--background-dark .bal-list__item button:not(.button):after{background:var(--bal-list-item-disabled-on-dark-background)}.bal-list--border.bal-list--background-dark .bal-list__item--disabled>div:after,.bal-list--border.bal-list--background-dark .bal-list__item--disabled a:not(.is-link):after,.bal-list--border.bal-list--background-dark .bal-list__item--disabled button:not(.button):after{background:var(--bal-list-item-disabled-on-dark-background)}.bal-list--border.bal-list--background-dark .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled)>div:hover:after,.bal-list--border.bal-list--background-dark .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) a:not(.is-link):hover:after,.bal-list--border.bal-list--background-dark .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) button:not(.button):hover:after{background:var(--bal-list-item-on-dark-background-hover)}.bal-list--border.bal-list--background-dark .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled)>div:active:after,.bal-list--border.bal-list--background-dark .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) a:not(.is-link):active:after,.bal-list--border.bal-list--background-dark .bal-list__item.bal-list__item--clickable:not(.bal-list__item--accordion):not(.bal-list__item--disabled) button:not(.button):active:after{background:var(--bal-list-item-on-dark-background-active)}.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__title .title,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__subtitle,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .title,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__subtitle,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__title .title,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__subtitle{color:var(--bal-list-item-disabled-on-dark-color) !important}.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg g,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg path,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg circle,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg g,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg path,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg g,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg path,.bal-list:not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg circle{fill:var(--bal-list-item-disabled-on-dark-fill) !important}.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__subtitle{color:var(--bal-list-item-disabled-color) !important}.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled:active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled):not(.bal-list--background-dark) .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg circle{fill:var(--bal-list-item-disabled-fill) !important}.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__subtitle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__title .title,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__title .bal-heading__text,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__subtitle{color:var(--bal-list-item-disabled-on-color-color) !important}.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled:active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-color .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled:active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled a:not(.is-link):active .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button) .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):hover .bal-list__item__icon svg circle,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg g,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg path,.bal-list:not(.bal-list--disabled).bal-list--background-dark .bal-list__item--disabled button:not(.button):active .bal-list__item__icon svg circle{fill:var(--bal-list-item-disabled-on-color-fill) !important}.bal-card>.bal-list.p-none .bal-list__item:last-child:after{content:none !important}.bal-list__item--accordion>div{-ms-flex-direction:column;flex-direction:column}.bal-list__item--animated{-webkit-transition:all var(--bal-animation-transition-duration) var(--bal-animation-transition-easing);transition:all var(--bal-animation-transition-duration) var(--bal-animation-transition-easing)}.bal-list__item--animated .bal-list__item__accordion-body{-webkit-transition:max-height var(--bal-animation-transition-duration) var(--bal-animation-transition-easing);transition:max-height var(--bal-animation-transition-duration) var(--bal-animation-transition-easing)}.bal-list__item--animated .bal-list__item__accordion-head__icon{-webkit-transition:-webkit-transform var(--bal-animation-transition-duration) var(--bal-animation-transition-easing);transition:-webkit-transform var(--bal-animation-transition-duration) var(--bal-animation-transition-easing);transition:transform var(--bal-animation-transition-duration) var(--bal-animation-transition-easing);transition:transform var(--bal-animation-transition-duration) var(--bal-animation-transition-easing), -webkit-transform var(--bal-animation-transition-duration) var(--bal-animation-transition-easing)}.bal-list__item__accordion-head{padding:0 !important}.bal-list__item__accordion-body{overflow:hidden;will-change:max-height;min-height:0;margin:0 !important}.bal-list__item__accordion-body,.bal-list__item__accordion-body__content{padding:0 !important}.bal-list__item--collapsing>.bal-list__item__trigger>.bal-list__item__accordion-body{max-height:0 !important}.bal-list__item--collapsed>.bal-list__item__trigger>.bal-list__item__accordion-body:not(.bal-list__item__accordion-body--grouped){display:none}.bal-list__item--collapsed>.bal-list__item__trigger>.bal-list__item__accordion-body--grouped{max-height:0 !important}.bal-list__item--expanding>.bal-list__item__trigger>.bal-list__item__accordion-body{max-height:0}@media (prefers-reduced-motion: reduce){.bal-list__item,.bal-list__item__accordion-body{-webkit-transition:none !important;transition:none !important}}.bal-list__item__accordion-body{-ms-flex-align:start !important;align-items:flex-start !important}.bal-list__item__accordion-body__content{position:static;display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;-ms-flex-direction:column;flex-direction:column;-ms-flex-align:start !important;align-items:flex-start !important}.bal-list__item__accordion-body__content--start{-ms-flex-pack:start;justify-content:flex-start}.bal-list__item__accordion-body__content--center{-ms-flex-pack:center;justify-content:center}.bal-list__item__accordion-body__content--end{-ms-flex-pack:end;justify-content:flex-end}.bal-list__item__accordion-body__content--space-between{-ms-flex-pack:justify;justify-content:space-between}.bal-list--border>.bal-list__item--expanded>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--border>.bal-list__item--expanding>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--border>.bal-list__item--collapsing>.bal-list__item__trigger>.bal-list__item__accordion-head:after{position:absolute;bottom:-0.5rem;left:0;content:\"\";height:2px;width:100%;border-radius:var(--bal-list-item-radius);background:var(--bal-list-item-border-background)}.bal-list--size-small.bal-list--border>.bal-list__item--expanded>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--size-small.bal-list--border>.bal-list__item--expanding>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--size-small.bal-list--border>.bal-list__item--collapsing>.bal-list__item__trigger>.bal-list__item__accordion-head:after{bottom:-2px}.bal-list--border.bal-list--background-color>.bal-list__item--expanded>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--border.bal-list--background-color>.bal-list__item--collapsing>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--border.bal-list--background-color>.bal-list__item--expanding>.bal-list__item__trigger>.bal-list__item__accordion-head:after{background:var(--bal-list-item-border-on-color-background)}.bal-list--border.bal-list--background-dark>.bal-list__item--expanded>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--border.bal-list--background-dark>.bal-list__item--collapsing>.bal-list__item__trigger>.bal-list__item__accordion-head:after,.bal-list--border.bal-list--background-dark>.bal-list__item--expanding>.bal-list__item__trigger>.bal-list__item__accordion-head:after{background:var(--bal-list-item-border-on-dark-background)}.bal-list__item__accordion-body__content>.bal-list{padding-left:1rem}.bal-list--background-dark .bal-list__item__accordion-body .bal-list__item__content>p{color:var(--bal-list-accordion-body-color)}.bal-list__item--animated>.bal-list__item__trigger{-webkit-transition:all var(--bal-animation-transition-duration) var(--bal-animation-transition-easing);transition:all var(--bal-animation-transition-duration) var(--bal-animation-transition-easing)}.bal-list__item--expanded>.bal-list__item__trigger,.bal-list__item--expanding>.bal-list__item__trigger{padding-bottom:0}.bal-list--border>.bal-list__item>.bal-list__item__trigger>.bal-list__item__accordion-body>div:not(.bal-list__item__accordion-body__content--space-normal){padding-bottom:2px !important}.bal-list__item__accordion-body__content{padding-top:.5rem !important}.bal-list__item__accordion-body__content--space-normal{padding-top:1rem !important;padding-bottom:1rem !important}";
const BalListStyle0 = balListCss;

const List = proxyCustomElement(class List extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.disabled = false;
        this.background = 'light';
        this.border = false;
        this.accordionOneLevel = false;
        this.size = '';
    }
    accordionOneLevelHandler(newValue, oldValue) {
        if (newValue !== oldValue) {
            const allNestedLists = Array.from(this.el.querySelectorAll('bal-list'));
            allNestedLists.forEach(list => (list.accordionOneLevel = newValue));
        }
    }
    componentWillLoad() {
        this.accordionOneLevelHandler(this.accordionOneLevel, false);
    }
    render() {
        const block = BEM.block('list');
        const closestListEl = this.el.closest('.bal-list');
        const nested = closestListEl !== null && closestListEl !== this.el;
        return (h(Host, { role: "list", class: Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, block.class()), block.modifier('nested').class(nested)), block.modifier('disabled').class(this.disabled)), block.modifier('border').class(this.border)), block.modifier(`size-${this.size || 'normal'}`).class()), block.modifier(`background-${this.background}`).class()) }, h("slot", null)));
    }
    get el() { return this; }
    static get watchers() { return {
        "accordionOneLevel": ["accordionOneLevelHandler"]
    }; }
    static get style() { return BalListStyle0; }
}, [4, "bal-list", {
        "disabled": [4],
        "background": [1],
        "border": [4],
        "accordionOneLevel": [4, "accordion-one-level"],
        "size": [1]
    }, undefined, {
        "accordionOneLevel": ["accordionOneLevelHandler"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["bal-list"];
    components.forEach(tagName => { switch (tagName) {
        case "bal-list":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, List);
            }
            break;
    } });
}

export { List as L, defineCustomElement as d };
