import{__awaiter,__generator,__spreadArray}from"tslib";import{r as registerInstance,c as createEvent,h,H as Host,g as getElement}from"./index-4d3658f6.js";import{k as rIC,m as debounceEvent}from"./helpers-b53ad333.js";import{i as inheritAttributes}from"./attributes-f95bca13.js";import{r as requiredArgs,t as toDate,b as toInteger,g as getDefaultOptions,p as parse,f as formatDateString,i as isValidIsoString,c as format,e as isSpaceKey,h as isEnterKey,d as dateSeparator,j as getYear,n as now,k as getMonth,m as getDate}from"./index.esm-ec4cba26.js";import{l as lodash_isnil}from"./index-82aff103.js";import{N as NUMBER_KEYS,A as ACTION_KEYS,i as isCtrlOrCommandKey}from"./keys.constant-0eb059e0.js";import{i as i18nBalDatepicker}from"./bal-datepicker.i18n-63a3cb67.js";import{s as stopEventBubbling,g as getInputTarget,i as inputHandleFocus,a as inputHandleHostClick,b as inputListenOnClick,c as inputSetFocus,d as inputSetBlur}from"./form-input-56444bfd.js";import{p as preventDefault}from"./utils-9fbab1d3.js";import{B as BEM}from"./bem-8c7d2eb0.js";import{L as Logger}from"./log-cf8e52ef.js";import{d as defaultBalAriaForm}from"./form-fb8dd9f5.js";import{d as defaultConfig,a as defaultLocale}from"./config.default-7d48bb87.js";import{b as balBreakpoints}from"./breakpoints.subject-bd83ea04.js";import{g as useBalConfig}from"./config.utils-8fe5be10.js";import{L as ListenToBreakpoints}from"./breakpoints.decorator-69c1d1da.js";import{L as ListenToConfig}from"./config.decorator-82894e30.js";import"./browser-a623d3a0.js";import"./icons.constant-47b0ca12.js";import"./_commonjsHelpers-1c8beb5f.js";import"./device-85159a44.js";import"./listener-aa4bfae3.js";import"./tokens.esm-7faeb0d0.js";function addDays(t,e){requiredArgs(2,arguments);var i=toDate(t);var r=toInteger(e);if(isNaN(r)){return new Date(NaN)}if(!r){return i}i.setDate(i.getDate()+r);return i}function addMonths(t,e){requiredArgs(2,arguments);var i=toDate(t);var r=toInteger(e);if(isNaN(r)){return new Date(NaN)}if(!r){return i}var a=i.getDate();var n=new Date(i.getTime());n.setMonth(i.getMonth()+r+1,0);var s=n.getDate();if(a>=s){return n}else{i.setFullYear(n.getFullYear(),n.getMonth(),a);return i}}function startOfWeek(t,e){var i,r,a,n,s,o,l,c;requiredArgs(1,arguments);var d=getDefaultOptions();var u=toInteger((i=(r=(a=(n=e===null||e===void 0?void 0:e.weekStartsOn)!==null&&n!==void 0?n:e===null||e===void 0?void 0:(s=e.locale)===null||s===void 0?void 0:(o=s.options)===null||o===void 0?void 0:o.weekStartsOn)!==null&&a!==void 0?a:d.weekStartsOn)!==null&&r!==void 0?r:(l=d.locale)===null||l===void 0?void 0:(c=l.options)===null||c===void 0?void 0:c.weekStartsOn)!==null&&i!==void 0?i:0);if(!(u>=0&&u<=6)){throw new RangeError("weekStartsOn must be between 0 and 6 inclusively")}var h=toDate(t);var f=h.getDay();var p=(f<u?7:0)+f-u;h.setDate(h.getDate()-p);h.setHours(0,0,0,0);return h}function startOfDay(t){requiredArgs(1,arguments);var e=toDate(t);e.setHours(0,0,0,0);return e}function addYears(t,e){requiredArgs(2,arguments);var i=toInteger(e);return addMonths(t,i*12)}function isSameDay(t,e){requiredArgs(2,arguments);var i=startOfDay(t);var r=startOfDay(e);return i.getTime()===r.getTime()}function lastDayOfMonth(t){requiredArgs(1,arguments);var e=toDate(t);var i=e.getMonth();e.setFullYear(e.getFullYear(),i+1,0);e.setHours(0,0,0,0);return e}function isAfter(t,e){requiredArgs(2,arguments);var i=toDate(t);var r=toDate(e);return i.getTime()>r.getTime()}function isBefore(t,e){requiredArgs(2,arguments);var i=toDate(t);var r=toDate(e);return i.getTime()<r.getTime()}function isSameWeek(t,e,i){requiredArgs(2,arguments);var r=startOfWeek(t,i);var a=startOfWeek(e,i);return r.getTime()===a.getTime()}function isSameMonth(t,e){requiredArgs(2,arguments);var i=toDate(t);var r=toDate(e);return i.getFullYear()===r.getFullYear()&&i.getMonth()===r.getMonth()}function isWithinInterval(t,e){requiredArgs(2,arguments);var i=toDate(t).getTime();var r=toDate(e.start).getTime();var a=toDate(e.end).getTime();if(!(r<=a)){throw new RangeError("Invalid interval")}return i>=r&&i<=a}function subDays(t,e){requiredArgs(2,arguments);var i=toInteger(e);return addDays(t,-i)}function subYears(t,e){requiredArgs(2,arguments);var i=toInteger(e);return addYears(t,-i)}var balDatepickerCss=':root{--bal-datepicker-popover-background:var(--bal-color-grey-2);--bal-datepicker-cell-background:var(--bal-color-white);--bal-datepicker-cell-selected-background:var(--bal-color-primary);--bal-datepicker-cell-selected-today-background:var(--bal-color-primary-inverted);--bal-datepicker-cell-today-background:var(--bal-color-primary);--bal-datepicker-cell-today-radius:var(--bal-radius-rounded)}.bal-datepicker{display:block;font-family:var(--bal-font-family-text);width:100%}.bal-datepicker__native{position:absolute !important;left:0;top:0;margin:0;padding:0;opacity:0;outline:0;border:none;width:1px;height:1px;clip:rect(1px, 1px, 1px, 1px);overflow:hidden}.bal-datepicker__popup{padding:1rem;width:100%;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;background-color:var(--bal-datepicker-popover-background)}@media screen and (min-width: 769px),print{.bal-datepicker__popup{max-width:24.5rem}}.bal-datepicker__popup__body{max-width:22.5rem;margin:0 auto 0 auto;margin-top:.75rem}.bal-datepicker-pagination{max-width:22.5rem;margin:0 auto 0 auto}.bal-datepicker-pagination__inner{display:-ms-flexbox;display:flex;gap:.5rem}.bal-datepicker-pagination__month-and-year{display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;gap:.5rem}.bal-datepicker-pagination__month-and-year__select{-ms-flex:1;flex:1}.bal-datepicker-pagination__month-and-year__select .select,.bal-datepicker-pagination__month-and-year__select .select select{padding-top:0 !important;padding-bottom:0 !important;text-align:center !important;min-height:2rem !important;height:2rem !important}@media screen and (min-width: 769px),print{.bal-datepicker-pagination__month-and-year__select .select,.bal-datepicker-pagination__month-and-year__select .select select{min-height:3rem !important;height:3rem !important}}.bal-datepicker-grid{display:table;border-collapse:collapse;width:100%;table-layout:fixed}.bal-datepicker-grid__body{display:table-row-group}.bal-datepicker-grid__row{display:table-row}.bal-datepicker-grid__row .bal-datepicker-grid__cell{margin-bottom:.25rem;margin-right:.25rem}.bal-datepicker-grid__row:last-child .bal-datepicker-grid__cell{margin-bottom:0}.bal-datepicker-grid__header{display:-ms-flexbox;display:flex;max-width:22.5rem;margin:0 auto 0 auto;gap:.25rem}.bal-datepicker-grid__header .bal-datepicker-grid__cell{background:rgba(0,0,0,0)}.bal-datepicker-grid__header .bal-datepicker-grid__cell span{display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;-ms-flex-align:center;align-items:center;height:100%;width:100%}.bal-datepicker-grid__cell{position:relative;text-align:center;vertical-align:middle;display:table-cell;width:13%;padding:0 !important;height:3rem;min-height:3rem;min-width:2.25rem;-webkit-appearance:auto !important;-moz-appearance:auto !important;appearance:auto !important;background:var(--bal-datepicker-cell-background)}.bal-datepicker-grid__cell--selected{background:var(--bal-datepicker-cell-selected-background) !important}.bal-datepicker-grid__cell--today:not(.bal-datepicker-grid__cell--outdated)>span{font-weight:var(--bal-weight-bold)}.bal-datepicker-grid__cell--today:not(.bal-datepicker-grid__cell--outdated)::after{content:"";position:absolute;display:block;width:.25rem;height:.25rem;background:var(--bal-datepicker-cell-today-background);border-radius:var(--bal-datepicker-cell-today-radius);margin-left:-2px;left:50%;bottom:.375rem}.bal-datepicker-grid__cell--today.bal-datepicker-grid__cell--selected:not(.bal-datepicker-grid__cell--outdated)::after{background:var(--bal-datepicker-cell-selected-today-background)}.bal-datepicker-grid__cell:last-child{margin-right:0}.bal-datepicker-grid__cell>span{font-family:var(--bal-font-family-text);font-weight:var(--bal-weight-regular)}@media screen and (min-width: 769px),print{.bal-datepicker-grid__cell{min-width:3rem !important}}.bal-datepicker-grid__cell--disabled{border-color:rgba(0,0,0,0) !important;background:rgba(0,0,0,0) !important}.bal-datepicker-grid__cell--header>span{border:none;background:rgba(0,0,0,0);color:var(--bal-color-text-primary);font-weight:var(--bal-weight-bold);cursor:default}';var BalDatepickerStyle0=balDatepickerCss;var __decorate=undefined&&undefined.__decorate||function(t,e,i,r){var a=arguments.length,n=a<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,i):r,s;if(typeof Reflect==="object"&&typeof Reflect.decorate==="function")n=Reflect.decorate(t,e,i,r);else for(var o=t.length-1;o>=0;o--)if(s=t[o])n=(a<3?s(n):a>3?s(e,i,n):s(e,i))||n;return a>3&&n&&Object.defineProperty(e,i,n),n};var Datepicker=function(){function t(t){var e=this;registerInstance(this,t);this.balChange=createEvent(this,"balChange",7);this.balInput=createEvent(this,"balInput",7);this.balBlur=createEvent(this,"balBlur",7);this.balFocus=createEvent(this,"balFocus",7);this.balInputClick=createEvent(this,"balInputClick",7);this.balIconClick=createEvent(this,"balIconClick",7);this.inputId="bal-dp-".concat(datepickerIds++);this.inheritedAttributes={};this.inputValue=this.value;this.onIconClick=function(t){if(!e.disabled&&!e.readonly){e.popoverElement.toggle()}stopEventBubbling(t);e.balIconClick.emit(t)};this.onInputClick=function(t){if(!e.triggerIcon&&!e.disabled&&!e.readonly){e.popoverElement.toggle()}stopEventBubbling(t);if(!e.triggerIcon){e.balInputClick.emit(t)}};this.onPopoverChange=function(t){stopEventBubbling(t);if(e.isPopoverOpen!==t.detail){e.isPopoverOpen=t.detail;e.fireBlur(t)}};this.onInput=function(t){var i=getInputTarget(t);if(i){e.inputValue=i.value;if(i.value){e.nativeInput.value=e.formatDate(e.inputValue)}if(e.inputValue&&e.inputValue.length>=6){var r=parse(e.inputValue,e.getLocale());var a=formatDateString(r);if(isValidIsoString(a)){e.selectedDate=a;e.updatePointerDates()}}}e.balInput.emit(e.inputValue)};this.onInputChange=function(t){var i=t.target.value;var r=parse(i,e.getLocale());var a=formatDateString(r);var n=format(e.getLocale(),r);e.nativeInput.value=n;e.updateValue(a);e.updatePointerDates()};this.onClickDateCell=function(t){if(!t.isDisabled){e.select(t.dateString)}};this.onInputKeyUp=function(t){if(isSpaceKey(t)&&!e.triggerIcon){if(e.isPopoverOpen){e.close()}else{e.open()}}if(isEnterKey(t)&&!e.triggerIcon){var i=parse(e.nativeInput.value,e.getLocale());var r=formatDateString(i);if(e.isPopoverOpen){if(e.value===r){e.close()}}}};this.onInputKeyDown=function(t){var i=dateSeparator(e.getLocale());var r=__spreadArray(__spreadArray(__spreadArray([],NUMBER_KEYS,true),[i],false),ACTION_KEYS,true);if(!isCtrlOrCommandKey(t)&&r.indexOf(t.key)<0){t.preventDefault();t.stopPropagation()}if(t.key==="Tab"){e.close()}};this.onMonthSelect=function(t){var i=t.target.value;e.pointerDate=Object.assign(Object.assign({},e.pointerDate),{day:1,month:parseInt(i,10)})};this.onYearSelect=function(t){var i=t.target.value;var r=parseInt(i,10);var a=undefined;if(e.defaultDate){var n=parse(e.defaultDate);if(e.max){var s=parse(e.max);if(n.getMonth()>s.getMonth()){a=s.getMonth()}}if(e.min){var o=parse(e.min);if(n.getMonth()<o.getMonth()){a=o.getMonth()}}}e.pointerDate={day:1,year:r,month:a!==undefined?a:e.pointerDate.month}};this.onInputFocus=function(t){return inputHandleFocus(e,t)};this.onInputBlur=function(t){preventDefault(t);e.focused=false;e.fireBlur(t)};this.fireBlur=function(t){if(!e.isPopoverOpen&&!e.focused){rIC((function(){return e.balBlur.emit(t)}))}};this.handleClick=function(t){return inputHandleHostClick(e,t)};this.language=defaultConfig.language;this.region=defaultConfig.region;this.isMobile=balBreakpoints.isMobile;this.focused=false;this.isPopoverOpen=false;this.selectedDate="";this.pointerDate={year:getYear(now()),month:getMonth(now()),day:getDate(now())};this.ariaForm=defaultBalAriaForm;this.name=this.inputId;this.invalid=false;this.required=false;this.disabled=false;this.readonly=false;this.loading=false;this.placeholder=undefined;this.min=undefined;this.max=undefined;this.closeOnSelect=true;this.triggerIcon=false;this.minYearProp=undefined;this.maxYearProp=undefined;this.debounce=0;this.defaultDate=undefined;this.value=undefined;this.allowedDates=undefined;this.autoInvalidOff=false}t.prototype.createLogger=function(t){this.log=t};t.prototype.debounceChanged=function(){this.balChange=debounceEvent(this.balChange,this.debounce)};t.prototype.valueChanged=function(){this.selectedDate=this.value;this.updatePointerDates()};t.prototype.listenOnClick=function(t){inputListenOnClick(this,t)};t.prototype.resetHandler=function(t){var e=this;var i=t.target;if(i===null||i===void 0?void 0:i.contains(this.el)){if(this.resetHandlerTimer){clearTimeout(this.resetHandlerTimer)}this.resetHandlerTimer=setTimeout((function(){if(e.initialValue){e.nativeInput.value=format(e.getLocale(),parse(e.initialValue))}else{e.nativeInput.value=""}e.selectedDate=e.initialValue;e.updateValue(e.initialValue,false);e.updatePointerDates()}),0)}};t.prototype.breakpointListener=function(t){this.isMobile=t.mobile};t.prototype.connectedCallback=function(){this.debounceChanged();this.initialValue=this.value};t.prototype.componentDidLoad=function(){this.inputValue=this.value};t.prototype.componentWillLoad=function(){this.inheritedAttributes=inheritAttributes(this.el,["aria-label","tabindex","title"]);this.selectedDate=this.value;this.updatePointerDates();this.updateValue(this.value,false)};t.prototype.configChanged=function(t){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){this.language=t.language;this.region=t.region;return[2]}))}))};t.prototype.open=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(t){if(!this.disabled&&this.popoverElement){this.popoverElement.present()}return[2]}))}))};t.prototype.close=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(t){if(!this.disabled&&this.popoverElement){this.popoverElement.dismiss()}return[2]}))}))};t.prototype.select=function(t){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(i){switch(i.label){case 0:this.nativeInput.value=format(this.getLocale(),parse(t));this.updateValue(t);this.updatePointerDates();if(!this.closeOnSelect)return[3,2];return[4,(e=this.popoverElement)===null||e===void 0?void 0:e.toggle()];case 1:i.sent();i.label=2;case 2:return[2]}}))}))};t.prototype.setFocus=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(t){inputSetFocus(this);return[2]}))}))};t.prototype.setBlur=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(t){inputSetBlur(this);return[2]}))}))};t.prototype.getInputElement=function(){return Promise.resolve(this.nativeInput)};t.prototype.setAriaForm=function(t){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){this.ariaForm=Object.assign({},t);return[2]}))}))};t.prototype.updatePointerDates=function(){var t=now();t.setDate(1);if(this.selectedDate){t=parse(this.selectedDate)}else{if(this.defaultDate){t=parse(this.defaultDate)}}if(this.min){var e=parse(this.min);if(e&&t<e){t=e}}if(this.max){var i=parse(this.max);if(i&&t>i){t=i}}this.pointerDate={year:getYear(t),month:getMonth(t),day:getDate(t)}};t.prototype.updateValue=function(t,e){if(e===void 0){e=true}if(!isValidIsoString(t)){this.selectedDate=undefined;this.value=undefined;if(this.nativeInput){this.nativeInput.value=""}}if(this.value!==t){this.value=t;if(e&&(this.isDateInRange(parse(this.value))||this.value==="")){this.balChange.emit(this.value)}}};Object.defineProperty(t.prototype,"minYear",{get:function(){if(this.min){return parseInt(this.min.substring(0,4),10)}return this.minYearProp?this.minYearProp:getYear(subYears(now(),100))},enumerable:false,configurable:true});Object.defineProperty(t.prototype,"maxYear",{get:function(){if(this.max){return parseInt(this.max.substring(0,4),10)}return this.maxYearProp?this.maxYearProp:getYear(addYears(now(),100))},enumerable:false,configurable:true});Object.defineProperty(t.prototype,"years",{get:function(){var t=this;var e=Array.from({length:this.maxYear-this.minYear+1},(function(e,i){return t.minYear+i}));if(this.min&&this.pointerDate.month===getMonth(parse(this.min))){var i=getYear(parse(this.min));e=e.filter((function(t){return t>=i}))}if(this.max&&this.pointerDate.month===getMonth(parse(this.max))){var r=getYear(parse(this.max));e=e.filter((function(t){return t<=r}))}return e},enumerable:false,configurable:true});Object.defineProperty(t.prototype,"months",{get:function(){var t=i18nBalDatepicker[this.language].monthsShort;var e=t.map((function(t,e){return{name:t,index:e}}));if(this.min&&this.pointerDate.year===getYear(parse(this.min))){var i=parseInt(this.min.substring(5,7),10)-1;e=e.filter((function(t){return t.index>=i}))}if(this.max&&this.pointerDate.year===getYear(parse(this.max))){var r=parseInt(this.max.substring(5,7),10)-1;e=e.filter((function(t){return t.index<=r}))}return e},enumerable:false,configurable:true});Object.defineProperty(t.prototype,"weekDays",{get:function(){var t=__spreadArray([],i18nBalDatepicker[this.language].weekdaysMin,true);t.push(t.shift()||"");return t},enumerable:false,configurable:true});Object.defineProperty(t.prototype,"firstDateOfBox",{get:function(){var t=new Date(this.pointerDate.year,this.pointerDate.month,1);return startOfWeek(t,{weekStartsOn:1})},enumerable:false,configurable:true});t.prototype.getLocale=function(){var t=useBalConfig();return t&&t.locale||defaultLocale};Object.defineProperty(t.prototype,"calendarGrid",{get:function(){var t=this.firstDateOfBox;var e=this.firstDateOfBox;var i=[];do{var r=[];do{r=__spreadArray(__spreadArray([],r,true),[{date:new Date(e),display:format(this.getLocale(),e),dateString:formatDateString(e),label:getDate(e).toString(),isToday:isSameDay(e,now()),isSelected:parse(this.selectedDate)!==undefined&&isSameDay(e,parse(this.selectedDate)),isDisabled:!this.getAllowedDates(e)||!this.isDateInRange(e),isOutdated:this.pointerDate.month!==e.getMonth()||!this.isDateInRange(e)}],false);e.setDate(e.getDate()+1)}while(isSameWeek(e,t,{weekStartsOn:1}));i=__spreadArray(__spreadArray([],i,true),[r],false);t.setDate(t.getDate()+7)}while(isSameMonth(new Date(this.pointerDate.year,this.pointerDate.month,this.pointerDate.day),e));return i},enumerable:false,configurable:true});t.prototype.getAllowedDates=function(t){if(lodash_isnil(this.allowedDates)){return true}return this.allowedDates(formatDateString(t))};t.prototype.formatDate=function(t){var e=dateSeparator(this.getLocale());var i=t.length;var r=t.charAt(i-1);var a=t.charAt(i-2);if(r===e){if(i===1||a===e||t.split(e).filter((function(t){return t.length>0})).length>=3){return t.substring(0,i-1)}}if(i===5){if(t.split(e)[0].split("").length===1&&a!==e&&r!==e){return t.substring(0,i-1)+e+t.substring(i-1,i)}}if(i===3||i===6){if(r!==e&&a!==e&&t.split(e).length<=2){return t.substring(0,i-1)+e+t.substring(i-1,i)}}return t};t.prototype.render=function(){var t=this;var e=BEM.block("datepicker");var i=e.element("native");var r=e.element("popup");var a=r.element("body");var n=r.element("footer");return h(Host,{onClick:this.handleClick,"aria-disabled":this.disabled?"true":null,class:Object.assign(Object.assign({},e.class()),e.modifier("disabled").class(this.disabled||this.readonly))},h("input",{type:"date",class:Object.assign({},i.class()),name:this.name,min:this.min,max:this.max,value:this.value,tabindex:-1,"aria-hidden":"true"}),h("bal-popover",{onBalChange:this.onPopoverChange,ref:function(e){return t.popoverElement=e}},this.renderInput(),h("bal-popover-content",{spaceless:true,contentMinWidth:392},h("div",{class:Object.assign({},r.class())},this.renderHeader(),h("div",{class:Object.assign({},a.class())},this.renderGrid()),h("div",{class:Object.assign({},n.class())},h("slot",null))))))};t.prototype.renderInput=function(){var t=this;return h("div",{"bal-popover-trigger":true,class:"control"},h("bal-input-group",{disabled:this.disabled||this.readonly,invalid:this.invalid},h("input",Object.assign({class:{input:true,"data-test-input":true,"is-clickable":!this.disabled&&!this.triggerIcon&&!this.readonly,"is-disabled":this.disabled||this.readonly,"is-danger":this.invalid},"data-testid":"bal-datepicker-input",ref:function(e){return t.nativeInput=e},id:this.ariaForm.controlId||this.inputId,"aria-labelledby":this.ariaForm.labelId,"aria-describedby":this.ariaForm.messageId,"aria-invalid":this.invalid===true?"true":"false","aria-disabled":this.disabled?"true":null,type:"text",maxlength:"10",autoComplete:"off",value:format(this.getLocale(),parse(this.value||"")),required:this.required,disabled:this.disabled,readonly:this.readonly,placeholder:this.placeholder,onKeyDown:function(e){return t.onInputKeyDown(e)},onKeyUp:function(e){return t.onInputKeyUp(e)},onInput:this.onInput,onClick:this.onInputClick,onChange:this.onInputChange,onBlur:this.onInputBlur,onFocus:this.onInputFocus},this.inheritedAttributes)),!this.loading?h("bal-icon",{class:{"datepicker-trigger-icon":true,"is-clickable":!this.disabled&&!this.readonly},"is-right":true,color:this.disabled||this.readonly?"grey":this.invalid?"danger":"primary",name:"date",onClick:this.onIconClick}):""))};t.prototype.renderGrid=function(){var t=this;var e=BEM.block("datepicker-grid");var i=e.element("row");var r=e.element("cell");return h("div",null,this.renderWeekDayHeader(),h("div",{class:Object.assign({},e.class())},this.calendarGrid.map((function(e){return h("div",{class:Object.assign({},i.class())},e.map((function(e){return h("button",{type:"button","data-date":e.dateString,onClick:function(){return t.onClickDateCell(e)},disabled:e.isDisabled,class:Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({},r.class()),{button:true,"is-text":!e.isDisabled&&!e.isSelected,"is-primary":e.isSelected&&e.isSelected,"is-disabled":e.isDisabled||e.isOutdated}),r.modifier("today").class(e.isToday)),r.modifier("selectable").class(!e.isDisabled&&!e.isOutdated)),r.modifier("disabled").class(e.isDisabled||e.isOutdated)),r.modifier("outdated").class(e.isOutdated)),r.modifier("selected").class(e.isSelected))},h("span",null,e.label))})))}))))};t.prototype.renderWeekDayHeader=function(){var t=BEM.block("datepicker-grid");var e=t.element("header");var i=t.element("cell");return h("header",{class:Object.assign({},e.class())},this.weekDays.map((function(t){return h("div",{class:Object.assign(Object.assign({},i.class()),i.modifier("header").class())},h("span",null,t))})))};t.prototype.renderHeader=function(){var t=this;var e=BEM.block("datepicker-pagination");var i=e.element("inner");var r=e.element("month-and-year");var a=r.element("select");return h("header",{class:Object.assign({},e.class())},h("div",{class:Object.assign({},i.class())},h("bal-button",{square:true,size:this.isMobile?"small":"",color:"info",icon:"nav-go-left",disabled:this.isPreviousMonthDisabled,onClick:function(){return t.previousMonth()}}),h("div",{class:Object.assign({},r.class())},h("div",{class:Object.assign(Object.assign({},a.class()),a.modifier("month").class())},h("div",{class:"select"},h("select",{onInput:this.onMonthSelect},this.months.map((function(e){return h("option",{value:e.index,selected:t.pointerDate.month===e.index},e.name)}))))),h("div",{class:Object.assign(Object.assign({},a.class()),a.modifier("year").class())},h("div",{class:"select"},h("select",{onInput:this.onYearSelect},this.years.map((function(e){return h("option",{value:e,selected:t.pointerDate.year===e},e)})))))),h("bal-button",{square:true,size:this.isMobile?"small":"",color:"info",icon:"nav-go-right",disabled:this.isNextMonthDisabled,onClick:function(){return t.nextMonth()}})))};t.prototype.previousMonth=function(){if(!this.isPreviousMonthDisabled){if(this.pointerDate.year===this.minYear&&this.pointerDate.month===0){return}this.pointerDate=this.calcPreviousMonth()}};t.prototype.nextMonth=function(){if(!this.isNextMonthDisabled){if(this.pointerDate.year===this.maxYear&&this.pointerDate.month===11){return}this.pointerDate=this.calcNextMonth()}};t.prototype.calcPreviousMonth=function(){if(this.pointerDate.month===0){return Object.assign(Object.assign({},this.pointerDate),{year:this.pointerDate.year-1,month:11,day:1})}else{return Object.assign(Object.assign({},this.pointerDate),{month:this.pointerDate.month-1,day:1})}};t.prototype.calcNextMonth=function(){if(this.pointerDate.month===11){return Object.assign(Object.assign({},this.pointerDate),{year:this.pointerDate.year+1,month:0,day:1})}else{return Object.assign(Object.assign({},this.pointerDate),{month:this.pointerDate.month+1,day:1})}};t.prototype.lastDayOfMonth=function(t,e){var i=new Date(t,e+1,0);return getDate(i)};Object.defineProperty(t.prototype,"isPreviousMonthDisabled",{get:function(){if(this.min){var t=parse(this.min);var e=this.lastDayOfMonth(this.calcPreviousMonth().year,this.calcPreviousMonth().month);var i=new Date(this.calcPreviousMonth().year,this.calcPreviousMonth().month,e);return isBefore(i,subDays(t,1))}return false},enumerable:false,configurable:true});Object.defineProperty(t.prototype,"isNextMonthDisabled",{get:function(){if(this.max){var t=parse(this.max);var e=new Date(this.calcNextMonth().year,this.calcNextMonth().month,1);return isAfter(e,lastDayOfMonth(t)?t:addDays(t,1))}return false},enumerable:false,configurable:true});t.prototype.isDateInRange=function(t){var e=parse(formatDateString(t));if(this.min&&this.max&&this.max>this.min){return isWithinInterval(e,{start:parse(this.min),end:parse(this.max)})}if(this.min){return isAfter(e,parse(this.min))||isSameDay(e,parse(this.min))}if(this.max){return isBefore(e,addDays(parse(this.max),1))||isSameDay(e,parse(this.max))}return true};Object.defineProperty(t.prototype,"el",{get:function(){return getElement(this)},enumerable:false,configurable:true});Object.defineProperty(t,"watchers",{get:function(){return{debounce:["debounceChanged"],value:["valueChanged"]}},enumerable:false,configurable:true});return t}();__decorate([Logger("bal-datepicker")],Datepicker.prototype,"createLogger",null);__decorate([ListenToBreakpoints()],Datepicker.prototype,"breakpointListener",null);__decorate([ListenToConfig()],Datepicker.prototype,"configChanged",null);var datepickerIds=0;Datepicker.style=BalDatepickerStyle0;export{Datepicker as bal_datepicker};