import{__awaiter,__extends,__generator}from"tslib";import{h as debounce,j as addEventListener,r as removeEventListener}from"./helpers-b53ad333.js";import{b as balBrowser}from"./browser-a623d3a0.js";import{b as balDevice}from"./device-85159a44.js";import{L as ListenerAbstract,S as Subject}from"./listener-aa4bfae3.js";import{e}from"./tokens.esm-7faeb0d0.js";var BalWindowResizeHandler=function(){function e(e){if(e===void 0){e={}}this.previousWidth=balBrowser.window.width;this.previousHeight=balBrowser.window.height;this.previousIsLandscape=this.isLandscape;this.options={onlyListenToWidthChanges:false};this.options=Object.assign(Object.assign({},this.options),e)}e.prototype.hasResized=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){if(balDevice.hasTouchScreen){if(!this.sameWidth||this.previousIsLandscape!==this.isLandscape){this.resetPreviousValues();return[2,true]}}else{if(this.options.onlyListenToWidthChanges){if(!this.sameWidth){this.resetPreviousValues();return[2,true]}}else{if(!this.sameWidth||!this.sameHeight){this.resetPreviousValues();return[2,true]}}}return[2,false]}))}))};Object.defineProperty(e.prototype,"isLandscape",{get:function(){return balBrowser.window.width>balBrowser.window.height},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"sameWidth",{get:function(){return this.previousWidth===balBrowser.window.width},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"sameHeight",{get:function(){return this.previousHeight===balBrowser.window.height},enumerable:false,configurable:true});e.prototype.resetPreviousValues=function(){this.previousWidth=balBrowser.window.width;this.previousHeight=balBrowser.window.height;this.previousIsLandscape=this.isLandscape};return e}();var BalWindowResizeListener=function(e){__extends(t,e);function t(){var t=e.apply(this,arguments)||this;t.resizeHandler=new BalWindowResizeHandler({onlyListenToWidthChanges:true});t.debouncedNotify=debounce((function(){return t.notify()}),10);t.notify=function(){return __awaiter(t,void 0,void 0,(function(){return __generator(this,(function(t){switch(t.label){case 0:return[4,this.resizeHandler.hasResized()];case 1:if(t.sent()){e.prototype.notify.call(this,undefined)}return[2]}}))}))};return t}t.prototype.connect=function(){e.prototype.connect.call(this);if(this.el){addEventListener(this.el,"resize",this.debouncedNotify,{passive:true})}};t.prototype.disconnect=function(){e.prototype.disconnect.call(this);if(this.el){removeEventListener(this.el,"resize",this.debouncedNotify)}};return t}(ListenerAbstract);var toNumber=function(e){return parseInt(e.slice(0,-2),10)};var breakpointTablet=toNumber(e.balBreakpointTablet);var breakpointDesktop=toNumber(e.balBreakpointDesktop);var breakpointHighDefinition=toNumber(e.balBreakpointHighDefinition);var breakpointWidescreen=toNumber(e.balBreakpointWidescreen);var balBreakpointFullhd=toNumber(e.balBreakpointFullhd);var isMobile=function(e){var t=e.innerWidth;return t<breakpointTablet};var isTablet=function(e){var t=e.innerWidth;return t>=breakpointTablet&&t<breakpointDesktop};var isTouch=function(e){return isMobile(e)||isTablet(e)};var isDesktop=function(e){return!isTouch(e)};var isHighDefinition=function(e){var t=e.innerWidth;return t>=breakpointHighDefinition&&t<breakpointWidescreen};var isWideScreen=function(e){var t=e.innerWidth;return t>=breakpointWidescreen&&t<balBreakpointFullhd};var isFullHD=function(e){var t=e.innerWidth;return t>=balBreakpointFullhd};var BREAKPOINTS_MAP={mobile:isMobile,tablet:isTablet,touch:isTouch,desktop:isDesktop,highDefinition:isHighDefinition,widescreen:isWideScreen,fullhd:isFullHD};var BalBreakpointsUtil=function(){function e(){this.breakpoints=[];if(balBrowser.hasWindow){this.win=window;this.win.BaloiseDesignSystem=this.win.BaloiseDesignSystem||{};this.detect()}}Object.defineProperty(e.prototype,"isMobile",{get:function(){return this.includes("mobile")},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"isTablet",{get:function(){return this.includes("tablet")},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"isTouch",{get:function(){return this.includes("touch")},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"isDesktop",{get:function(){return this.includes("desktop")},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"isHighDefinition",{get:function(){return this.includes("highDefinition")},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"isWidescreen",{get:function(){return this.includes("widescreen")},enumerable:false,configurable:true});Object.defineProperty(e.prototype,"isFullHD",{get:function(){return this.includes("fullhd")},enumerable:false,configurable:true});e.prototype.includes=function(e){var t;this.detect();return!!((t=this.breakpoints)===null||t===void 0?void 0:t.includes(e))};e.prototype.detect=function(){var e=this;if(this.win){this.breakpoints=Object.keys(BREAKPOINTS_MAP).filter((function(t){return BREAKPOINTS_MAP[t](e.win)}));this.win.BaloiseDesignSystem.breakpoints=this.breakpoints;this.win.BaloiseDesignSystem.platforms=this.breakpoints}return this.breakpoints};e.prototype.toObject=function(){return{mobile:this.breakpoints.includes("mobile"),tablet:this.breakpoints.includes("tablet"),touch:this.breakpoints.includes("touch"),desktop:this.breakpoints.includes("desktop"),highDefinition:this.breakpoints.includes("highDefinition"),widescreen:this.breakpoints.includes("widescreen"),fullhd:this.breakpoints.includes("fullhd")}};return e}();var balBreakpoints=new BalBreakpointsUtil;var initialBreakpoints={mobile:false,tablet:false,touch:false,desktop:false,highDefinition:false,widescreen:false,fullhd:false};var BalBreakpointSubject=function(e){__extends(t,e);function t(){var t=e.call(this,(function(e){return e.breakpointListener(t.state)}))||this;t.state=initialBreakpoints;t.listener=new BalWindowResizeListener;t.debouncedNotify=debounce((function(){return t.notify()}),50);t.listener.connect();t.listener.add((function(){balBreakpoints.detect();var e=balBreakpoints.toObject();if(!t.isEqual(e)){t.state=e;t.debouncedNotify()}}));return t}t.prototype.attach=function(t){e.prototype.attach.call(this,t);balBreakpoints.detect();var i=balBreakpoints.toObject();if(!this.isEqual(i)){this.state=i;this.debouncedNotify()}};t.prototype.isEqual=function(e){return JSON.stringify(this.state)===JSON.stringify(e)};return t}(Subject);var balBreakpointSubject=new BalBreakpointSubject;export{BalWindowResizeListener as B,balBreakpointSubject as a,balBreakpoints as b,BalBreakpointSubject as c,BalBreakpointsUtil as d};